@echo off

:: Define Variables
SET _ToolVersion=1.0.0 B005
SET _titlebar=SecureAuth WarmUp Tool %_ToolVersion%
SET _legal=decline
SET _CECHO="%~dp0bin\cecho.exe"
SET _ErrorStatus=FALSE
SET _ErrorRealm=
SET _RegReadErr=3016015350



CALL :ReadRegistry HKEY_LOCAL_MACHINE\SOFTWARE\SecureAuth\Warmup ToolInstalled _ToolInstalled

 IF %_RegReadErr% EQU FALSE (
  CALL :WarmUp
  GOTO :EOF
 ) 

 IF %_RegReadErr% EQU TRUE (
  echo initial setup 
  CALL :InitialSetup
  GOTO :EOF
 )

 
 
:InitialSetup
CALL :WriteEventLog INFORMATION 100 "Initial configuration of the WarmUp tool is beginning." > NUL
COLOR 1F

:: Set title bar
TITLE %_titlebar%

:: Check if we have administrative privileges. If we don't engage UAC and request the rights.  

REM  --> Check for permissions
>nul 2>&1 "%SYSTEMROOT%\system32\cacls.exe" "%SYSTEMROOT%\system32\config\system"

REM --> If error flag set, we do not have admin.
if '%errorlevel%' NEQ '0' (
    echo. ========================================
    echo. * This script requires administrative  * 
    echo. * privileges to operate.               *       
    echo. ========================================    
    echo. 
    echo   Requesting administrative privileges...
    echo.
    goto UACPrompt
) else ( goto gotAdmin )

:UACPrompt
    echo Set UAC = CreateObject^("Shell.Application"^) > "%temp%\getadmin.vbs"
    set params = %*:"=""
    echo UAC.ShellExecute "%~s0", "%params%", "", "runas", 1 >> "%temp%\getadmin.vbs"

    "%temp%\getadmin.vbs"
    exit 

:gotAdmin
    if exist "%temp%\getadmin.vbs" ( del "%temp%\getadmin.vbs" )
    pushd "%CD%"
    CD /D "%~dp0"
	

cls
echo.
echo. 
echo.      
echo. 
echo. 
echo.
echo       ͻ
echo                                                                          
echo                              SecureAuth WarmUp Tool                      
echo                                                                          
echo       ͹
echo                                                                          
echo                                                                          
echo          This tool is used to Warm Up a SecureAuth IdP appliance making  
echo          initial visits to realms respond more quickly to users.         
echo                                                                          
echo                                                                          
echo       ͼ
echo.
echo                            {Press any key to continue}
echo.

timeout.exe 10 >> NUL

cls
echo.
echo      ͻ
echo                                                                         
echo                             SecureAuth WarmUp Tool                      
echo                                                                         
echo      ͹
echo                                                                         
echo                                                                         
echo            BY CONTINUING YOU ARE AGREEING TO THE LEGAL TERMS BELOW.      
echo                 
echo                                                                         
echo        THIS SOFTWARE IS PROVIDED "AS IS" AND SECUREAUTH CORPORATION     
echo        DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING  
echo        ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO     
echo        EVENT SHALL SECUREAUTH CORPORATION BE LIABLE FOR ANY SPECIAL,    
echo        DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES        
echo        WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER  
echo        IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,   
echo        ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF   
echo        THIS SOFTWARE.                                                   
echo                                                                         
echo      ͼ
echo.

echo      Please type "AGREE" to accept the legal terms: | "%~dp0bin\tr\tr.exe" -d \r\n
SET/p _legal=

IF /I %_legal% NEQ AGREE (
 CALL :displayError00
 GOTO :EOF
)



cls
echo   ͻ
echo                                                                             
echo                              SecureAuth WarmUp Tool                         
echo                                                                             
echo   ͹
%_CECHO%                                Environment Check                            {1F}{\r\n}  
echo ͼ
echo.


echo.
echo                 Detect Windows OS: | "%~dp0bin\tr\tr.exe" -d \r\n

ver | find "5.2" > nul
IF %ERRORLEVEL% == 0 SET _applianceOSVer=WinSrv2003
IF %ERRORLEVEL% == 0 SET _osFriendlyName=Windows Server 2003

ver | find "6.0" > nul
IF %ERRORLEVEL% == 0 SET _applianceOSVer=WinSrv2008
IF %ERRORLEVEL% == 0 SET _osFriendlyName=Windows Server 2008

ver | find "6.1" > nul
IF %ERRORLEVEL% == 0 SET _applianceOSVer=WinSrv2008r2
IF %ERRORLEVEL% == 0 SET _osFriendlyName=Windows Server 2008 R2
 
ver | find "6.2" > nul
IF %ERRORLEVEL% == 0 SET _applianceOSVer=WinSrv2012
IF %ERRORLEVEL% == 0 SET _osFriendlyName=Windows Server 2012

ver | find "6.3" > nul
IF %ERRORLEVEL% == 0 SET _applianceOSVer=WinSrv2012r2
IF %ERRORLEVEL% == 0 SET _osFriendlyName=Windows Server 2012 R2

%_CECHO% {1E}%_osFriendlyName% {1F}{\n}


IF %_applianceOSVer% EQU WinSrv2003 (
 CALL :displayError01
 GOTO :EOF
)


IF %_applianceOSVer% EQU WinSrv2008 (
 CALL :displayError02
 GOTO :EOF
)



echo.
echo.
echo                 Detect SecureAuth: | "%~dp0bin\tr\tr.exe" -d \r\n

IF EXIST D:\SecureAuth ( 
 %_CECHO% {1E}SecureAuth IdP Present {1F}{\n}
)

IF NOT EXIST D:\SecureAuth ( 
 %_CECHO% {1E}SecureAuth IdP NOT Preset {1F}{\n}
 timeout.exe 2 > NUL
 CALL :displayError03
)

timeout.exe 3 > NUL

cls
echo   ͻ
echo                                                                             
echo                              SecureAuth WarmUp Tool                         
echo                                                                             
echo   ͹
%_CECHO%                              Configure Preferences                          {1F}{\r\n}  
echo ͼ
echo.

echo.
echo.
echo.
echo.
%_CECHO%             {1E}Please enter an interval ^(in minutes^) to create a  {1F}{\r\n} 
%_CECHO%            {1E}schedule for the WarmUp script to run. {1F}{\r\n} 
echo. 
echo             SecureAuth recommends between 60 and 240 minutes
echo             for optimal performance. 
echo.

%_CECHO%            {1E} Interval ^(in minutes^):{1F} 
SET/p_RunInterval=
)




cls
echo   ͻ
echo                                                                             
echo                              SecureAuth WarmUp Tool                         
echo                                                                             
echo   ͼ
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo         Ŀ
echo                                                                        
echo                             Configuring Environemnt...                 
echo                                                                        
echo         


:: Schedule the warm up script to run 
schtasks /create /sc minute /mo %_RunInterval% /tn "SecureAuth WarmUp Tool" /tr "%~dp0WarmUp.bat" /f >nul 2>&1

:: Write preferences to registry
reg add "HKEY_LOCAL_MACHINE\SOFTWARE\SecureAuth\Warmup" /v "ToolInstalled" /t REG_SZ /d "TRUE" /f >NUL

timeout.exe 3 > NUL



cls
echo.
echo. 
echo.      
echo. 
echo. 
echo.
echo.
echo.
echo       ͻ
echo                                                                          
echo                            SecureAuth WarmUp Tool                        
echo                                                                          
echo       ͹
echo                                                                          
echo                The configuration process has sompleted successfully.     
echo                                                                          
echo       ͼ
echo.
echo                            {Press any key to continue}
timeout.exe 15 >> NUL 
CALL :WriteEventLog INFORMATION 101 "Initial configuration of the WarmUp tool has completed successfully." > NUL
GOTO :EOF



:WarmUp
SET _WarmRealms=
setlocal ENABLEDELAYEDEXPANSION
FOR /D %%G in ("D:\SecureAuth\SecureAuth*") DO ( 
 IF %%~NXG NEQ SecureAuth0 (
   IF %%~NXG NEQ SecureAuth999 (
    SET _WarmRealms=!_WarmRealms!%%~NXG, >nul 2>&1
    CALL :OpenHTTPSConnection %%~nxG >nul 2>&1
   )  
  )
)

:: Warm Up SecureAuth0, the administrative interface. 
CALL :OpenHTTPSConnection SecureAuth0 >nul 2>&1
SET _WarmRealms=!_WarmRealms!and SecureAuth0 >nul 2>&1


CALL :WriteEventLog INFORMATION 102 "Warm Up of the realms !_WarmRealms! completed successfully." > NUL
endlocal
GOTO :EOF
   
   
:: ---------------------------------------------------------------------
:: ---------------------------------------------------------------------
::                      Code Subroutines 
:: ---------------------------------------------------------------------
:: ---------------------------------------------------------------------

:WriteEventLog

:: Pass TYPE [SUCCESS, ERROR, WARNING, INFORMATION] 
::      ID [A number between 1 - 1000.]  
::      Log Message  

eventcreate /T %~1 /L APPLICATION /SO "SecureAuth WarmUp Tool" /ID %~2 /D "%~3"   
GOTO :EOF



:ReadRegistry
:: %~1 KeyName 
:: %~2 ValueName  
:: %~3 Variable Name 

reg query "%~1" /v %~2 > NUL 2>&1

IF %errorlevel% GTR 0 (
 SET _RegReadErr=TRUE
)

IF %errorlevel% EQU 0 (
 SET _RegReadErr=FALSE
 for /f "tokens=2*" %%a in ('reg query "%~1" /v %~2 2^>^&1^|find "REG_"') do @set %~3=%%b
)

GOTO :EOF



:CheckIISActive
for /F "tokens=3 delims=: " %%H in ('sc query "W3SVC" ^| findstr "        STATE"') do (
  if /I "%%H" NEQ "RUNNING" (
   REM Put your code you want to execute here
   REM For example, the following line
   net start "MyServiceName"
  )
)



:OpenHTTPSConnection
:: %~1 SecureAuth Realm
"%~dp0bin\wget\wget.exe" -nv --spider https://localhost/%~1 --no-check-certificate >nul 2>&1
GOTO :EOF 



:: ---------------------------------------------------------------------
:: ---------------------------------------------------------------------
::                      Error Subroutines 
:: ---------------------------------------------------------------------
:: ---------------------------------------------------------------------

:displayError00
cls
echo.
echo. 
echo.      
echo. 
echo. 
echo.
echo       ͻ
echo                                                                          
echo                            SecureAuth WarmUp Tool                        
echo                                                                          
echo       ͹
echo                                                                          
echo                     You have declined the legal agreement.               
echo                        The WarmUp script will now exit.                  
echo                                                                          
echo       ͼ
echo.
echo                          {Press any key to continue}
timeout.exe 15 >> NUL 
CALL :WriteEventLog INFORMATION 105 "User declined the legal agreement." > NUL
GOTO :EOF



:displayError01
cls
echo.
echo. 
echo.      
echo. 
echo. 
echo.
echo       ͻ
echo                                                                          
echo                            SecureAuth WarmUp Tool                        
echo                                                                          
echo       ͹
echo                                                                          
echo              The SecureAuth WarmUp Tool does not support Microsoft       
echo              Windows Server 2003.                                        
echo                                                                          
echo       ͼ
echo.
echo                          {Press any key to continue}
timeout.exe 15 >> NUL 
CALL :WriteEventLog ERROR 200 "Microsoft Windows Server 2003 is not a supported operating system." > NUL
GOTO :EOF



:displayError02
cls
echo.
echo. 
echo.      
echo. 
echo. 
echo.
echo       ͻ
echo                                                                          
echo                            SecureAuth WarmUp Tool                        
echo                                                                          
echo       ͹
echo                                                                          
echo              The SecureAuth WarmUp Tool does not support Microsoft       
echo              Windows Server 2008.                                        
echo                                                                          
echo       ͼ
echo.
echo                          {Press any key to continue}
timeout.exe 15 >> NUL 
CALL :WriteEventLog ERROR 201 "Microsoft Windows Server 2008 is not a supported operating system." > NUL
GOTO :EOF



:displayError03
cls
echo.
echo. 
echo.      
echo. 
echo. 
echo.
echo       ͻ
echo                                                                          
echo                            SecureAuth WarmUp Tool                        
echo                                                                          
echo       ͹
echo                                                                          
echo              A SecureAuth IdP installation could not be found on         
echo              this appliance.                                             
echo                                                                          
echo       ͼ
echo.
echo                          {Press any key to continue}
timeout.exe 15 >> NUL 
CALL :WriteEventLog ERROR 202 "A SecureAuth IdP installation could not be found on this appliance." > NUL
GOTO :EOF


:EOF